"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
/* eslint-disable react/jsx-no-leaked-render */
/* eslint-disable jsx-a11y/no-static-element-interactions */
var react_1 = require("react");
var icon_js_1 = require("./icon.js");
var context_js_1 = require("../context.js");
var EyeDropper_js_1 = __importDefault(require("./EyeDropper.js"));
var constants_js_1 = require("../constants.js");
var AdvancedControls_js_1 = __importDefault(require("./AdvancedControls.js"));
var ComparibleColors_js_1 = __importDefault(require("./ComparibleColors.js"));
var GradientControls_js_1 = __importDefault(require("./GradientControls.js"));
var styles_js_1 = require("../styles/styles.js");
var defaultColor = constants_js_1.config.defaultColor, defaultGradient = constants_js_1.config.defaultGradient;
var ColorTypeBtns = function (_a) {
    var _b, _c;
    var hideColorTypeBtns = _a.hideColorTypeBtns, isGradient = _a.isGradient, setSolid = _a.setSolid, setGradient = _a.setGradient, locales = _a.locales;
    var defaultStyles = (0, context_js_1.usePicker)().defaultStyles;
    if (hideColorTypeBtns) {
        return (0, jsx_runtime_1.jsx)("div", { style: { width: 1 } });
    }
    else {
        return ((0, jsx_runtime_1.jsxs)("div", { style: __assign({ display: 'flex', alignItems: 'center' }, defaultStyles.rbgcpControlBtnWrapper), children: [(0, jsx_runtime_1.jsx)("div", { onClick: setSolid, id: "rbgcp-solid-btn", style: (0, styles_js_1.colorTypeBtnStyles)(!isGradient, defaultStyles), children: (_b = locales === null || locales === void 0 ? void 0 : locales.CONTROLS) === null || _b === void 0 ? void 0 : _b.SOLID }), (0, jsx_runtime_1.jsx)("div", { onClick: setGradient, id: "rbgcp-gradient-btn", style: (0, styles_js_1.colorTypeBtnStyles)(isGradient || false, defaultStyles), children: (_c = locales === null || locales === void 0 ? void 0 : locales.CONTROLS) === null || _c === void 0 ? void 0 : _c.GRADIENT })] }));
    }
};
var InputTypeDropdown = function (_a) {
    var openInputType = _a.openInputType, setOpenInputType = _a.setOpenInputType;
    var _b = (0, context_js_1.usePicker)(), inputType = _b.inputType, setInputType = _b.setInputType, defaultStyles = _b.defaultStyles;
    var vTrans = openInputType
        ? 'visibility 0ms linear'
        : 'visibility 100ms linear 150ms';
    var zTrans = openInputType
        ? 'z-index 0ms linear'
        : 'z-index 100ms linear 150ms';
    var oTrans = openInputType
        ? 'opacity 120ms linear'
        : 'opacity 150ms linear 50ms';
    var handleInputType = function (e, val) {
        if (openInputType) {
            e.stopPropagation();
            setInputType(val);
            setOpenInputType(false);
        }
    };
    return ((0, jsx_runtime_1.jsxs)("div", { style: __assign({ visibility: openInputType ? 'visible' : 'hidden', zIndex: openInputType ? '' : -100, opacity: openInputType ? 1 : 0, transition: "".concat(oTrans, ", ").concat(vTrans, ", ").concat(zTrans) }, defaultStyles.rbgcpColorModelDropdown), children: [(0, jsx_runtime_1.jsx)("div", { onClick: function (e) { return handleInputType(e, 'rgb'); }, style: (0, styles_js_1.modalBtnStyles)(inputType === 'rgb', defaultStyles), children: "RGB" }), (0, jsx_runtime_1.jsx)("div", { onClick: function (e) { return handleInputType(e, 'hsl'); }, style: (0, styles_js_1.modalBtnStyles)(inputType === 'hsl', defaultStyles), children: "HSL" }), (0, jsx_runtime_1.jsx)("div", { onClick: function (e) { return handleInputType(e, 'hsv'); }, style: (0, styles_js_1.modalBtnStyles)(inputType === 'hsv', defaultStyles), children: "HSV" }), (0, jsx_runtime_1.jsx)("div", { onClick: function (e) { return handleInputType(e, 'cmyk'); }, style: (0, styles_js_1.modalBtnStyles)(inputType === 'cmyk', defaultStyles), children: "CMYK" })] }));
};
var Controls = function (_a) {
    var locales = _a.locales, _b = _a.hideEyeDrop, hideEyeDrop = _b === void 0 ? false : _b, _c = _a.hideAdvancedSliders, hideAdvancedSliders = _c === void 0 ? false : _c, _d = _a.hideColorGuide, hideColorGuide = _d === void 0 ? false : _d, _e = _a.hideInputType, hideInputType = _e === void 0 ? false : _e, _f = _a.hideColorTypeBtns, hideColorTypeBtns = _f === void 0 ? false : _f, _g = _a.hideGradientControls, hideGradientControls = _g === void 0 ? false : _g, _h = _a.hideGradientType, hideGradientType = _h === void 0 ? false : _h, _j = _a.hideGradientAngle, hideGradientAngle = _j === void 0 ? false : _j, _k = _a.hideGradientStop, hideGradientStop = _k === void 0 ? false : _k;
    var _l = (0, context_js_1.usePicker)(), onChange = _l.onChange, isGradient = _l.isGradient, handleChange = _l.handleChange, previous = _l.previous, defaultStyles = _l.defaultStyles;
    var _m = (0, react_1.useState)(false), openComparibles = _m[0], setOpenComparibles = _m[1];
    var _o = (0, react_1.useState)(false), openInputType = _o[0], setOpenInputType = _o[1];
    var _p = (0, react_1.useState)(false), openAdvanced = _p[0], setOpenAdvanced = _p[1];
    var noTools = hideEyeDrop && hideAdvancedSliders && hideColorGuide && hideInputType;
    var solidColor = (previous === null || previous === void 0 ? void 0 : previous.color) || defaultColor;
    var gradientColor = (previous === null || previous === void 0 ? void 0 : previous.gradient) || defaultGradient;
    var setSolid = function () {
        onChange(solidColor);
    };
    var setGradient = function () {
        onChange(gradientColor);
    };
    var allRightControlsHidden = hideEyeDrop && hideAdvancedSliders && hideColorGuide && hideInputType;
    var allControlsHidden = allRightControlsHidden && hideColorTypeBtns;
    if (allControlsHidden) {
        if (isGradient && !hideGradientControls) {
            return ((0, jsx_runtime_1.jsx)(GradientControls_js_1.default, { hideGradientType: hideGradientType, hideGradientAngle: hideGradientAngle, hideGradientStop: hideGradientStop }));
        }
        else {
            return null;
        }
    }
    else {
        return ((0, jsx_runtime_1.jsxs)("div", { style: { paddingTop: 12, paddingBottom: 4 }, children: [(0, jsx_runtime_1.jsxs)("div", { style: {
                        width: '100%',
                        display: 'flex',
                        alignItems: 'center',
                        justifyContent: 'space-between',
                    }, children: [(0, jsx_runtime_1.jsx)(ColorTypeBtns, { hideColorTypeBtns: hideColorTypeBtns, setGradient: setGradient, isGradient: isGradient, setSolid: setSolid, locales: locales }), !allRightControlsHidden && ((0, jsx_runtime_1.jsxs)("div", { style: __assign({ display: noTools ? 'none' : '' }, defaultStyles.rbgcpControlBtnWrapper), children: [!hideEyeDrop && (0, jsx_runtime_1.jsx)(EyeDropper_js_1.default, { onSelect: handleChange }), (0, jsx_runtime_1.jsx)("div", { id: "rbgcp-advanced-btn", onClick: function () { return setOpenAdvanced(!openAdvanced); }, style: __assign({ display: hideAdvancedSliders ? 'none' : 'flex' }, (0, styles_js_1.controlBtnStyles)(openAdvanced, defaultStyles)), children: (0, jsx_runtime_1.jsx)(icon_js_1.SlidersIcon, { color: openAdvanced ? '#568CF5' : '' }) }), (0, jsx_runtime_1.jsx)("div", { id: "rbgcp-comparibles-btn", style: __assign({ display: hideColorGuide ? 'none' : 'flex' }, (0, styles_js_1.controlBtnStyles)(openComparibles, defaultStyles)), onClick: function () { return setOpenComparibles(!openComparibles); }, children: (0, jsx_runtime_1.jsx)(icon_js_1.PaletteIcon, { color: openComparibles ? '#568CF5' : '' }) }), (0, jsx_runtime_1.jsxs)("div", { id: "rbgcp-color-model-btn", onClick: function () { return setOpenInputType(!openInputType); }, style: __assign({ display: hideInputType ? 'none' : 'flex' }, (0, styles_js_1.controlBtnStyles)(openInputType, defaultStyles)), children: [(0, jsx_runtime_1.jsx)(icon_js_1.InputsIcon, { color: openInputType ? '#568CF5' : '' }), (0, jsx_runtime_1.jsx)(InputTypeDropdown, { openInputType: openInputType, setOpenInputType: setOpenInputType })] })] }))] }), !hideAdvancedSliders && ((0, jsx_runtime_1.jsx)(AdvancedControls_js_1.default, { openAdvanced: openAdvanced })), !hideColorGuide && ((0, jsx_runtime_1.jsx)(ComparibleColors_js_1.default, { openComparibles: openComparibles })), isGradient && !hideGradientControls && ((0, jsx_runtime_1.jsx)(GradientControls_js_1.default, { hideGradientType: hideGradientType, hideGradientAngle: hideGradientAngle, hideGradientStop: hideGradientStop }))] }));
    }
};
exports.default = Controls;
