"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var context_js_1 = require("../context.js");
var formatters_js_1 = require("../utils/formatters.js");
var styles_js_1 = require("../styles/styles.js");
var icon_js_1 = __importStar(require("./icon.js"));
var GradientType = function () {
    var _a = (0, context_js_1.usePicker)(), gradientType = _a.gradientType, onChange = _a.onChange, value = _a.value, defaultStyles = _a.defaultStyles;
    var isLinear = gradientType === 'linear-gradient';
    var isRadial = gradientType === 'radial-gradient';
    var handleLinear = function () {
        var remaining = value.split(/,(.+)/)[1];
        onChange("linear-gradient(90deg, ".concat(remaining));
    };
    var handleRadial = function () {
        var remaining = value.split(/,(.+)/)[1];
        onChange("radial-gradient(circle, ".concat(remaining));
    };
    return ((0, jsx_runtime_1.jsxs)("div", { style: defaultStyles.rbgcpControlBtnWrapper, children: [(0, jsx_runtime_1.jsx)("div", { onClick: handleLinear, id: "rbgcp-linear-btn", style: __assign(__assign({}, defaultStyles.rbgcpControlBtn), (isLinear && defaultStyles.rbgcpControlBtnSelected)), tabIndex: 0, role: "button", onKeyDown: function () {
                    return;
                }, children: (0, jsx_runtime_1.jsx)(icon_js_1.LinearIcon, { color: isLinear ? '#568CF5' : '' }) }), (0, jsx_runtime_1.jsx)("div", { onClick: handleRadial, id: "rbgcp-radial-btn", style: __assign(__assign({}, defaultStyles.rbgcpControlBtn), (isRadial && defaultStyles.rbgcpControlBtnSelected)), tabIndex: 0, role: "button", onKeyDown: function () {
                    return;
                }, children: (0, jsx_runtime_1.jsx)(icon_js_1.RadialIcon, { color: isRadial ? '#568CF5' : '' }) })] }));
};
var StopPicker = function () {
    var _a = (0, context_js_1.usePicker)(), currentLeft = _a.currentLeft, handleGradient = _a.handleGradient, currentColor = _a.currentColor, defaultStyles = _a.defaultStyles;
    var handleMove = function (newVal) {
        handleGradient(currentColor, (0, formatters_js_1.formatInputValues)(parseInt(newVal), 0, 100));
    };
    return ((0, jsx_runtime_1.jsxs)("div", { style: __assign(__assign(__assign(__assign({}, defaultStyles.rbgcpControlBtnWrapper), defaultStyles.rbgcpControlInputWrap), defaultStyles.rbgcpStopInputWrap), { paddingLeft: 8 }), children: [(0, jsx_runtime_1.jsx)(icon_js_1.StopIcon, {}), (0, jsx_runtime_1.jsx)("input", { value: currentLeft, id: "rbgcp-stop-input", onChange: function (e) { return handleMove(e.target.value); }, style: __assign(__assign({}, defaultStyles.rbgcpControlInput), defaultStyles.rbgcpStopInput) })] }));
};
var DegreePicker = function () {
    var _a = (0, context_js_1.usePicker)(), degrees = _a.degrees, onChange = _a.onChange, value = _a.value, defaultStyles = _a.defaultStyles;
    var handleDegrees = function (e) {
        var newValue = (0, formatters_js_1.formatInputValues)(e.target.value, 0, 360);
        var remaining = value.split(/,(.+)/)[1];
        onChange("linear-gradient(".concat(newValue || 0, "deg, ").concat(remaining));
    };
    return ((0, jsx_runtime_1.jsxs)("div", { style: __assign(__assign(__assign({}, defaultStyles.rbgcpControlBtnWrapper), defaultStyles.rbgcpControlInputWrap), defaultStyles.rbgcpDegreeInputWrap), children: [(0, jsx_runtime_1.jsx)(icon_js_1.DegreesIcon, {}), (0, jsx_runtime_1.jsx)("input", { value: degrees, id: "rbgcp-degree-input", onChange: function (e) { return handleDegrees(e); }, style: __assign(__assign({}, defaultStyles.rbgcpControlInput), defaultStyles.rbgcpDegreeInput) }), (0, jsx_runtime_1.jsx)("div", { style: __assign(__assign({}, defaultStyles.rbgcpDegreeIcon), { position: 'absolute', right: degrees > 99 ? 0 : degrees < 10 ? 7 : 3, top: 1, fontWeight: 400, fontSize: 13 }), children: "\u00B0" })] }));
};
var DeleteBtn = function () {
    var _a = (0, context_js_1.usePicker)(), colors = _a.colors, selectedColor = _a.selectedColor, createGradientStr = _a.createGradientStr, defaultStyles = _a.defaultStyles;
    var deletePoint = function () {
        if ((colors === null || colors === void 0 ? void 0 : colors.length) > 2) {
            var formatted = colors === null || colors === void 0 ? void 0 : colors.map(function (fc, i) { return (__assign(__assign({}, fc), { value: i === selectedColor - 1 ? (0, formatters_js_1.high)(fc) : (0, formatters_js_1.low)(fc) })); });
            var remaining = formatted === null || formatted === void 0 ? void 0 : formatted.filter(function (_, i) { return i !== selectedColor; });
            createGradientStr(remaining);
        }
    };
    return ((0, jsx_runtime_1.jsx)("div", { onClick: deletePoint, style: __assign(__assign({}, (0, styles_js_1.controlBtnStyles)(false, defaultStyles)), { width: 28 }), id: "rbgcp-point-delete-btn", tabIndex: 0, role: "button", onKeyDown: function () {
            return;
        }, children: (0, jsx_runtime_1.jsx)(icon_js_1.default, {}) }));
};
var GradientControls = function (_a) {
    var hideGradientType = _a.hideGradientType, hideGradientAngle = _a.hideGradientAngle, hideGradientStop = _a.hideGradientStop;
    var _b = (0, context_js_1.usePicker)(), gradientType = _b.gradientType, defaultStyles = _b.defaultStyles;
    return ((0, jsx_runtime_1.jsxs)("div", { style: __assign(__assign({}, defaultStyles.rbgcpControlBtnWrapper), { marginTop: 12, marginBottom: -4, justifyContent: 'space-between', paddingLeft: hideGradientType ? 4 : 0 }), id: "rbgcp-gradient-controls-wrap", children: [!hideGradientType && (0, jsx_runtime_1.jsx)(GradientType, {}), (0, jsx_runtime_1.jsx)("div", { style: { width: 53 }, children: !hideGradientAngle && gradientType === 'linear-gradient' && ((0, jsx_runtime_1.jsx)(DegreePicker, {})) }), !hideGradientStop && (0, jsx_runtime_1.jsx)(StopPicker, {}), (0, jsx_runtime_1.jsx)(DeleteBtn, {})] }));
};
exports.default = GradientControls;
